/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
package net.micode.notes.gtask.remote;
 
import android.app.Activity;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.IBinder;
 
// GTaskSyncService 是一个用于同步任务的服务类
public class GTaskSyncService extends Service {
    // 定义同步操作的 action 类型名称
    public final static String ACTION_STRING_NAME = "sync_action_type";
 
    // 定义开始同步的 action 类型
    public final static int ACTION_START_SYNC = 0;
 
    // 定义取消同步的 action 类型
    public final static int ACTION_CANCEL_SYNC = 1;
 
    // 定义无效的 action 类型
    public final static int ACTION_INVALID = 2;
 
    // 定义同步服务广播名称
    public final static String GTASK_SERVICE_BROADCAST_NAME = "net.micode.notes.gtask.remote.gtask_sync_service";
 
    // 定义同步服务广播中是否正在同步的键名
    public final static String GTASK_SERVICE_BROADCAST_IS_SYNCING = "isSyncing";
 
    // 定义同步服务广播中进度信息的键名
    public final static String GTASK_SERVICE_BROADCAST_PROGRESS_MSG = "progressMsg";
 
    // 静态变量，用于存储同步任务实例
    private static GTaskASyncTask mSyncTask = null;
 
    // 静态变量，用于存储同步进度信息
    private static String mSyncProgress = "";
 
    // 启动同步任务的方法
    private void startSync() {
        if (mSyncTask == null) {
            mSyncTask = new GTaskASyncTask(this, new GTaskASyncTask.OnCompleteListener() {
                public void onComplete() {
                    mSyncTask = null;
                    sendBroadcast("");
                    stopSelf();
                }
            });
            sendBroadcast("");
            mSyncTask.execute();
        }
    }
 
    // 取消同步任务的方法
    private void cancelSync() {
        if (mSyncTask != null) {
            mSyncTask.cancelSync();
        }
    }
 
    // 服务创建时的回调方法
    @Override
    public void onCreate() {
        mSyncTask = null;
    }
 
    // 服务启动命令的回调方法
    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Bundle bundle = intent.getExtras();
        if (bundle != null && bundle.containsKey(ACTION_STRING_NAME)) {
            switch (bundle.getInt(ACTION_STRING_NAME, ACTION_INVALID)) {
                case ACTION_START_SYNC:
                    startSync();
                    break;
                case ACTION_CANCEL_SYNC:
                    cancelSync();
                    break;
                default:
                    break;
            }
            return START_STICKY;
        }
        return super.onStartCommand(intent, flags, startId);
    }
 
    // 服务内存不足时的回调方法
    @Override
    public void onLowMemory() {
        if (mSyncTask != null) {
            mSyncTask.cancelSync();
        }
    }
 
    // 返回服务的 IBinder 对象
    public IBinder onBind(Intent intent) {
        return null;
    }
 
    // 发送同步进度广播的方法
    public void sendBroadcast(String msg) {
        mSyncProgress = msg;
        Intent intent = new Intent(GTASK_SERVICE_BROADCAST_NAME);
        intent.putExtra(GTASK_SERVICE_BROADCAST_IS_SYNCING, mSyncTask != null);
        intent.putExtra(GTASK_SERVICE_BROADCAST_PROGRESS_MSG, msg);
        sendBroadcast(intent);
    }
 
    // 静态方法，用于启动同步服务
    public static void startSync(Activity activity) {
        GTaskManager.getInstance().setActivityContext(activity);
        Intent intent = new Intent(activity, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_START_SYNC);
        activity.startService(intent);
    }
 
    // 静态方法，用于取消同步服务
    public static void cancelSync(Context context) {
        Intent intent = new Intent(context, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_CANCEL_SYNC);
        context.startService(intent);
    }
 
    // 检查是否正在同步的方法
    public static boolean isSyncing() {
        return mSyncTask != null;
    }
 
    // 获取同步进度信息的方法
    public static String getProgressString() {
        return mSyncProgress;
    }
}